/* Boyd Key Establishment Protocol

- Klt is the long term key shared only between A and B
- pk(Ra) is a fresh public key of A for the run Ra
- K is the session key (short term key)

A -> B: {pk(Ra),B}+Klt
B -> A: {K}*pk(Ra), {h(K),A}+Klt

*/

initiator(A,B,Ra,Klt,Kst,[ 
   send([pk(Ra),B]+Klt),
   recv([Kst*pk(Ra),[sha(Kst),A]+Klt]),
   end(A,B,init,Ra,Klt,Kst)
 ]).

responder(A,B,Ra,Klt,Kst,[
   recv([pk(Ra),B]+Klt),
   send([Kst*pk(Ra),[sha(Kst),A]+Klt]),
   end(B,A,resp,Ra,Klt,Kst)
 ]).

leak(X,[send(X)]).

ik([a,b,e]).

% perfect forward secrecy (to verify, try timeout 300 secs)
scenario([[a,Init1],[b,Resp1],[l,Leak]],
              all(A,all(B,all(N,all(Klt,learn(Klt) and yest (once ([_,end(A,B,init,N,Klt,kst)] and neg learn(kst))) 
                    imp neg learn(kst)))))
             ) :-
   initiator(a,b,na,klt,Kst,Init1),
   responder(a,b,Na,klt,kst,Resp1),
   leak(klt,Leak). 


                         

