% CCITT X.509 (one message protocol)

% Initiator role specification
initiator(A,B,Na,Ta,Xa,Ya,[ 
   recv([A,B]), % orig. assumption
   run(A,B,init,Na,Ta,Xa,Ya),
   send([A,[Ta,[Na,[B,[Xa,Ya*pk(B)]]]]/pk(A)]),
   end(A,B,init,Na,Ta,Xa,Ya)
 ]).

% Responder role specification
responder(A,B,Na,Ta,Xa,Ya,[
   recv([A,[Ta,[Na,[B,[Xa,Ya*pk(B)]]]]/pk(A)]),
   end(B,A,resp,Na,Ta,Xa,Ya)
 ]).

% aliveness test
scenario([[a,Init1],[b,Resp1]],
      all(A,all(B,all(D11,all(D12,all(D13,all(D14,
         some(A1,some(R1,some(D21,some(D22,some(D23,some(D24,
            [_,end(A,B,init,D11,D12,D13,D14)] imp once [_,run(B,A1,R1,D21,D22,D23,D24)]))))))))))))
               ) :-
   initiator(a,b,na,ta,xa,ya,Init1),
   responder(I,b,Na,Ta,Xa,Ya,Resp1).

% weak agreement test
scenario([[a,Init1],[b,Resp1]],
      all(A,all(B,all(D11,all(D12,all(D13,all(D14,
         some(D21,some(D22,some(D23,some(D24,
            [_,end(A,B,init,D11,D12,D13,D14)] imp once [_,end(B,A,resp,D21,D22,D23,D24)]))))))))))
               ) :-
   initiator(a,b,na,ta,xa,ya,Init1),
   responder(I,b,Na,Ta,Xa,Ya,Resp1).

% Set up the initial intruder knowledge
ik([a,b,e]).


