% DEBT -- Patched protocol example

% Initiator role specification
initiator(A,B,Nb,[ 
   recv(B), % orig. assumption
   start(A,B,init),
   send(A),
   recv([Nb,B]*pk(A)),
   run(A,B,init,Nb),
   send(Nb*pk(B)),
   end(A,B,init,Nb)
 ]).

% Responder role specification
responder(A,B,Nb,[
    start(A,B,init),
    recv(A),
    run(B,A,resp,Nb),	
    send([Nb,B]*pk(A)),
    recv(Nb*pk(B)),
    end(B,A,resp,Nb)
 ]).

% initial intruder knowledge
ik([a,b,e]).

% secrecy test
scenario([[a,Init1],[b,Resp1]],neg learn(nb)) :-
   initiator(a,_,_,Init1),
   responder(a,b,nb,Resp1).

% aliveness test
scenario([[a,Init1],[b,Resp1]],
      all(A,all(B,all(D11,
         some(A1,some(R1,
            [_,end(A,B,resp,D11)] imp once [_,start(B,A1,R1)])))))
               ) :-
   initiator(a,_,_,Init1),
   responder(a,b,nb,Resp1).

% weak agreement test
scenario([[a,Init1],[b,Resp1]],
      all(A,all(B,all(D11,
         some(R1,
            [_,end(A,B,resp,D11)] imp once [_,start(B,A,R1)]))))
               ) :-
   initiator(a,_,_,Init1),
   responder(a,b,nb,Resp1).

% non-injective agreement test
scenario([[a,Init1],[b,Resp1]],
      all(A,all(B,all(D1,
            [_,end(A,B,resp,D1)] imp once [_,run(B,A,init,D1)])))
               ) :-
   initiator(a,_,_,Init1),
   responder(a,b,nb,Resp1).




