
% Kao Chow

initiator(A,B,Na,Nb,Kas,Kab,Kbs,[ 
   recv([A,B]),                 % for origination assumption
   start(A,B,init),
   send([A,[B,Na]]),
   recv([ [A,[B,[Na,Kab]]]+Kas,
          [ Na+Kab, Nb ]
 	]),
   run(A,B,init,Na,Nb,Kab),
   send(Nb+Kab),
   end(A,B,init,Na,Nb,Kab)
 ]).

responder(A,B,Na,Nb,M,Kab,Kbs,[ 
   start(B,A,resp),
   recv([ M,
          ([A,[B,[Na,Kab]]]+Kbs)
 	]),
   run(B,A,resp,Na,Nb,Kab),
   send([ M,
          [ Na+Kab, Nb ]
 	]),
   recv(Nb+Kab),
   end(B,A,resp,Na,Nb,Kab),
%  we model that the key kab was compromised...
  send(Kab)
 ]).

server(A,B,Na,Kas,Kab,Kbs,[ 
   recv([A,[B,Na]]),
   run(S,A,B,serv,Kas,Kbs,Kab),
   send([ ([A,[B,[Na,Kab]]]+Kas),
          ([A,[B,[Na,Kab]]]+Kbs)
 	]),
   end(S,A,B,serv,Kas,Kbs,Kab)
 ]).

ik([a,b,e]).

% aliveness test
scenario([[a1,Sa1],[b1,Sb1],[b2,Sb2],[s,Ss]],
      all(A,all(B,all(D11,all(D12,all(D13,
         some(A1,some(R1,
            [_,end(A,B,resp,D11,D12,D13)] imp once [_,start(B,A1,R1)])))))))
               ) :-
	initiator(a,b,na,Nb,kas,Kab,Kbs,Sa1),
	responder(a,b,Na1,nb1,M,Kab1,kbs,Sb1),
	responder(a,b,Na2,nb2,M2,Kab2,kbs,Sb2),
	server(a,b,Na3,kas,kab,kbs,Ss).

% weak agreement test
scenario([[a1,Sa1],[b1,Sb1],[b2,Sb2],[s,Ss]],
      all(A,all(B,all(D11,all(D12,all(D13,
         some(R1,
            [_,end(A,B,resp,D11,D12,D13)] imp once [_,start(B,A,R1)]))))))
               ) :-
	initiator(a,b,na,Nb,kas,Kab,Kbs,Sa1),
	responder(a,b,Na1,nb1,M,Kab1,kbs,Sb1),
	responder(a,b,Na2,nb2,M2,Kab2,kbs,Sb2),
	server(a,b,Na3,kas,kab,kbs,Ss).

% non-injective agreement test
scenario([[a1,Sa1],[b1,Sb1],[b2,Sb2],[s,Ss]],
      all(A,all(B,all(D11,all(D12,all(D13,
            [_,end(A,B,resp,D11,D12,D13)] imp once [_,run(B,A,init,D11,D12,D13)])))))
               ) :-
	initiator(a,b,na,Nb,kas,Kab,Kbs,Sa1),
	responder(a,b,Na1,nb1,M,Kab1,kbs,Sb1),
	responder(a,b,Na2,nb2,M2,Kab2,kbs,Sb2),
	server(a,b,Na3,kas,kab,kbs,Ss).

