% Needham Schroeder Public Key Protocol

initiator(A,B,Na,Nb,[ 
   recv(B),                 % for origination assumption
   start(A,B,init),
   send([A,Na]*pk(B)),
   recv([Na,Nb]*pk(A)),
   run(A,B,init,Na,Nb),
   send(Nb*pk(B)),
   end(A,B,init,Na,Nb)
 ]).

responder(A,B,Na,Nb,[
    start(B,A,resp),
    recv([A,Na]*pk(B)),
    run(B,A,resp,Na,Nb),
    send([Na,Nb]*pk(A)),
    recv(Nb*pk(B)),
    end(B,A,resp,Na,Nb)
 ]).

ik([a,b,e]).

% uncomment the scenario to test

% secrecy test
scenario([[a,Init1],[b,Resp1]],neg learn(nb)) :-
   initiator(a,R,na,Nb,Init1),
   responder(a,b,Na,nb,Resp1).

% aliveness test
scenario([[a,Init1],[b,Resp1]],
      all(A,all(B,all(D11,all(D12,
         some(A1,some(R1,
            [_,end(A,B,resp,D11,D12)] imp once [_,start(B,A1,R1)]))))))
               ) :-
   initiator(a,R,na,Nb,Init1),
   responder(a,b,Na,nb,Resp1).

% weak agreement test
scenario([[a,Init1],[b,Resp1]],
      all(A,all(B,all(D11,all(D12,
         some(R1,
            [_,end(A,B,resp,D11,D12)] imp once [_,start(B,A,R1)])))))
               ) :-
   initiator(a,R,na,Nb,Init1),
   responder(a,b,Na,nb,Resp1).

% non-injective agreement test
scenario([[a,Init1],[b,Resp1]],
      all(A,all(B,all(D1,all(D2,
            [_,end(A,B,resp,D1,D2)] imp once [_,run(B,A,init,D1,D2)]))))
               ) :-
   initiator(a,R,na,Nb,Init1),
   responder(a,b,Na,nb,Resp1).

