/* 
Lowe's Andrew Secure RPC 
1.   A -> B :   A, Na 
2.   B -> A :   {Na, K'ab,B}Kab 
3.   A -> B :   {Na}K'ab 
*/

initiator(A,B,Na,KabM,KabS,[ 
   start(A,B,init),
   send([A,Na]),
   recv([Na,[KabS,B]]+KabM),
   run(A,B,init,Na,KabM,KabS),
   send(Na+KabS),
   end(A,B,init,Na,KabM,KabS)
 ]).

responder(A,B,Na,KabM,KabS,[
   start(B,A,resp),
   recv([A,Na]),
   run(B,A,resp,Na,KabM,KabS),
   send([Na,[KabS,B]]+KabM),
   recv(Na+KabS),
   end(B,A,resp,Na,KabM,KabS)
 ]).

leak(X,[send(X)]).

ik([a,b,e]).

% secrecy test
scenario([[a,Init1],[b,Resp1]],neg learn(kabs)) :-
   initiator(a,B,na,kabm,KabS,Init1),
   responder(A,b,Na,kabm,kabs,Resp1).

% aliveness of B when A as a responder completes the protocol
scenario([[a1,Init1],[b2,Init2],[a2,Resp2]],
      all(A,all(B,all(D11,all(D12,all(D13,
         some(A1,some(R1,
            [_,end(A,B,resp,D11,D12,D13)] imp once [_,start(B,A1,R1)])))))))
               ) :-
   initiator(a,b,na,kabm,KabS1,Init1),
   initiator(b,a,nb,kabm,KabS2,Init2),
   responder(b,a,Nb,kabm,kabs2,Resp2).

% perfect forward secrecy
scenario([[a,Init1],[b,Resp1],[l,Leak]],
              all(A,all(B,all(N,all(Klt,learn(Klt) and yest (once ([_,end(B,A,resp,N,Klt,kabs)] and neg learn(kabs))) 
                    imp neg learn(kabs)))))
             ) :-
   initiator(a,b,na,kabm,KabS,Init1),
   responder(a,b,Na,kabm,kabs,Resp1),
   leak(kabm,Leak). 

% freshness of the session key                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               !
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
scenario([[a1,Init1],[a2,Resp2]],
   all(A,all(B1,all(R1,all(D11,all(D12,all(K,all(B2,all(R2,all(D21,all(D22,
                yest (once [_,end(A,B1,R1,D11,D12,K)]) 
                   imp neg [_,end(A,B2,R2,D21,D22,K)]))))))))))
              ) :-
   initiator(a,b,na,kabm,KabS,Init1),
   responder(b,a,Nb,kabm,kabs,Resp2).

% indication for denial of service attack
scenario([[a,Init1],[b,Resp1]],
   all(A,all(B,all(D11,all(D12,all(D13,
      [_,run(A,B,resp,D11,D12,D13)] imp once [_,start(B,A,init)])))))
              ) :-
   initiator(a,b,na,kabm,KabS,Init1),
   responder(a,b,Na,kabm,kabs,Resp1).

