
% TMN 

initiator(A,B,S,R1,R2,[ 
%   recv([A,[S,B]]),                 % for origination assumption
   start(A,B,init),
   send([A,[S,[B,R1*pk(S)]]]),
   recv([S,[A,[B,R2+R1]]]),
   end(A,B,init,R2)
 ]).

responder(A,B,S,R2,[
    start(B,A,resp),
    recv([S,[B,A]]),
    run(B,A,resp,R2),
    send([B,[S,[A,R2*pk(S)]]]),
    end(B,A,resp,R2)
 ]).

server(A,B,S,R1,R2, [
    recv(B),
    recv([A,[S,[B,R1*pk(S)]]]),
    send([S,[B,A]]),
    recv([B,[S,[A,R2*pk(S)]]]),
    send([S,[A,[B,R2+R1]]])
 ]).

% secrecy test
scenario([
	   [a,Init1],
           [b,Resp1],
           [s,Serv1]
           ],neg learn(r2)
          ) :-
initiator(a,b,s,r1,R2,Init1),
responder(a,b,s,r2,Resp1),
server(a,b,s,R11,R22, Serv1).


% aliveness test
scenario([
	   [a,Init1],
           [b,Resp1],
           [s,Serv1]
           ],      
    all(A,all(B,all(D11,all(D12,
         some(A1,some(R1,
            [_,end(A,B,init,D11,D12)] imp once [_,start(B,A1,R1)]))))))
          ) :-
initiator(a,b,s,r1,R2,Init1),
responder(a,b,s,r2,Resp1),
server(I,R,s,R11,R22, Serv1).

% Set up the initial intruder knowledge
ik([a,b,e,s]).




